; Swordfish Structured BASIC Compiler for PICmicros.
; Version 1.1.5.1 SE Copyright Mecanique 2007
;
; C:\Documents and Settings\dady\Desktop\rgbled\rgb.BAS 6/24/2009
;
 PROCESSOR PIC18F1320
 RADIX DEC
 ERRORLEVEL 2
 EXPAND ON
; SPECIAL FUNCTION REGISTERS...
TOSU             EQU 0X0FFF
TOSH             EQU 0X0FFE
TOSLH            EQU 0X0FFE
TOSL             EQU 0X0FFD
STKPTR           EQU 0X0FFC
PCLATU           EQU 0X0FFB
PCLATH           EQU 0X0FFA
PCL              EQU 0X0FF9
TBLPTRU          EQU 0X0FF8
TBLPTRH          EQU 0X0FF7
TBLPTRLH         EQU 0X0FF7
TBLPTRL          EQU 0X0FF6
TABLAT           EQU 0X0FF5
PRODH            EQU 0X0FF4
PRODLH           EQU 0X0FF4
PRODL            EQU 0X0FF3
INTCON           EQU 0X0FF2
INTCON2          EQU 0X0FF1
INTCON3          EQU 0X0FF0
INDF0            EQU 0X0FEF
POSTINC0         EQU 0X0FEE
POSTDEC0         EQU 0X0FED
PREINC0          EQU 0X0FEC
PLUSW0           EQU 0X0FEB
FSR0H            EQU 0X0FEA
FSR0LH           EQU 0X0FEA
FSR0L            EQU 0X0FE9
WREG             EQU 0X0FE8
INDF1            EQU 0X0FE7
POSTINC1         EQU 0X0FE6
POSTDEC1         EQU 0X0FE5
PREINC1          EQU 0X0FE4
PLUSW1           EQU 0X0FE3
FSR1H            EQU 0X0FE2
FSR1LH           EQU 0X0FE2
FSR1L            EQU 0X0FE1
BSR              EQU 0X0FE0
INDF2            EQU 0X0FDF
POSTINC2         EQU 0X0FDE
POSTDEC2         EQU 0X0FDD
PREINC2          EQU 0X0FDC
PLUSW2           EQU 0X0FDB
FSR2H            EQU 0X0FDA
FSR2LH           EQU 0X0FDA
FSR2L            EQU 0X0FD9
STATUS           EQU 0X0FD8
TMR0H            EQU 0X0FD7
TMR0LH           EQU 0X0FD7
TMR0L            EQU 0X0FD6
T0CON            EQU 0X0FD5
OSCCON           EQU 0X0FD3
LVDCON           EQU 0X0FD2
WDTCON           EQU 0X0FD1
RCON             EQU 0X0FD0
TMR1H            EQU 0X0FCF
TMR1LH           EQU 0X0FCF
TMR1L            EQU 0X0FCE
T1CON            EQU 0X0FCD
TMR2             EQU 0X0FCC
PR2              EQU 0X0FCB
T2CON            EQU 0X0FCA
ADRESH           EQU 0X0FC4
ADRESLH          EQU 0X0FC4
ADRESL           EQU 0X0FC3
ADCON0           EQU 0X0FC2
ADCON1           EQU 0X0FC1
ADCON2           EQU 0X0FC0
CCPR1H           EQU 0X0FBF
CCPR1LH          EQU 0X0FBF
CCPR1L           EQU 0X0FBE
CCP1CON          EQU 0X0FBD
PWM1CON          EQU 0X0FB7
ECCPAS           EQU 0X0FB6
TMR3H            EQU 0X0FB3
TMR3LH           EQU 0X0FB3
TMR3L            EQU 0X0FB2
T3CON            EQU 0X0FB1
SPBRGH           EQU 0X0FB0
SPBRG            EQU 0X0FAF
RCREG            EQU 0X0FAE
TXREG            EQU 0X0FAD
TXSTA            EQU 0X0FAC
RCSTA            EQU 0X0FAB
BAUDCTL          EQU 0X0FAA
EEADR            EQU 0X0FA9
EEDATA           EQU 0X0FA8
EECON2           EQU 0X0FA7
EECON1           EQU 0X0FA6
IPR2             EQU 0X0FA2
PIR2             EQU 0X0FA1
PIE2             EQU 0X0FA0
IPR1             EQU 0X0F9F
PIR1             EQU 0X0F9E
PIE1             EQU 0X0F9D
OSCTUNE          EQU 0X0F9B
TRISB            EQU 0X0F93
TRISA            EQU 0X0F92
LATB             EQU 0X0F8A
LATA             EQU 0X0F89
; SYSTEM PORTS...
PORTB            EQU 0X0F81
PORTA            EQU 0X0F80
; STKPTR
STKFUL = 7
STKUNF = 6
SP4 = 4
SP3 = 3
SP2 = 2
SP1 = 1
SP0 = 0
; INTCON
GIE = 7
GIEH = 7
PEIE = 6
GIEL = 6
TMR0IE = 5
INT0IE = 4
RBIE = 3
TMR0IF = 2
INT0IF = 1
RBIF = 0
; INTCON2
NOT_RBPU = 7
RBPU = 7
INTEDG0 = 6
INTEDG1 = 5
INTEDG2 = 4
TMR0IP = 2
T0IP = 2
RBIP = 0
; INTCON3
INT2IP = 7
INT1IP = 6
INT2IE = 4
INT1IE = 3
INT2IF = 1
INT1IF = 0
; STATUS
N = 4
OV = 3
Z = 2
DC = 1
C = 0
; T0CON
TMR0ON = 7
T08BIT = 6
T0CS = 5
T0SE = 4
PSA = 3
T0PS2 = 2
T0PS1 = 1
T0PS0 = 0
; OSCCON
IDLEN = 7
IRCF2 = 6
IRCF1 = 5
IRCF0 = 4
OSTS = 3
IOFS = 2
SCS1 = 1
SCS0 = 0
; LVDCON
IRVST = 5
LVDEN = 4
LVDL3 = 3
LVDL2 = 2
LVDL1 = 1
LVDL0 = 0
; WDTCON
SWDTEN = 0
; RCON
IPEN = 7
NOT_RI = 4
RI = 4
NOT_TO = 3
TO = 3
NOT_PD = 2
PD = 2
NOT_POR = 1
POR = 1
NOT_BOR = 0
BOR = 0
; T1CON
RD16 = 7
T1RUN = 6
T1CKPS1 = 5
T1CKPS0 = 4
T1OSCEN = 3
NOT_T1SYNC = 2
T1SYNC = 2
TMR1CS = 1
TMR1ON = 0
; T2CON
TOUTPS3 = 6
TOUTPS2 = 5
TOUTPS1 = 4
TOUTPS0 = 3
TMR2ON = 2
T2CKPS1 = 1
T2CKPS0 = 0
; ADCON0
VCFG1 = 7
VCFG0 = 6
CHS2 = 4
CHS1 = 3
CHS0 = 2
GO = 1
NOT_DONE = 1
DONE = 1
GO_DONE = 1
ADON = 0
; ADCON1
PCFG6 = 6
PCFG5 = 5
PCFG4 = 4
PCFG3 = 3
PCFG2 = 2
PCFG1 = 1
PCFG0 = 0
; ADCON2
ADFM = 7
ACQT2 = 5
ACQT1 = 4
ACQT0 = 3
ADCS2 = 2
ADCS1 = 1
ADCS0 = 0
; CCP1CON
P1M1 = 7
P1M0 = 6
DC1B1 = 5
DC1B0 = 4
CCP1M3 = 3
CCP1M2 = 2
CCP1M1 = 1
CCP1M0 = 0
; PWM1CON
PRSEN = 7
PDC6 = 6
PDC5 = 5
PDC4 = 4
PDC3 = 3
PDC2 = 2
PDC1 = 1
PDC0 = 0
; ECCPAS
ECCPASE = 7
ECCPAS2 = 6
ECCPAS1 = 5
ECCPAS0 = 4
PSSAC1 = 3
PSSAC0 = 2
PSSBD1 = 1
PSSBD0 = 0
; T3CON
RD16 = 7
T3CCP2 = 6
T3CKPS1 = 5
T3CKPS0 = 4
T3CCP1 = 3
NOT_T3SYNC = 2
T3SYNC = 2
TMR3CS = 1
TMR3ON = 0
; TXSTA
CSRC = 7
TX9 = 6
TXEN = 5
SYNC = 4
SENDB = 3
BRGH = 2
TRMT = 1
TX9D = 0
; RCSTA
SPEN = 7
RX9 = 6
SREN = 5
CREN = 4
ADDEN = 3
FERR = 2
OERR = 1
RX9D = 0
; BAUDCTL
RCIDL = 6
SCKP = 4
BRG16 = 3
WUE = 1
ABDEN = 0
; EECON1
EEPGD = 7
CFGS = 6
FREE = 4
WRERR = 3
WREN = 2
WR = 1
RD = 0
; IPR2
OSCFIP = 7
EEIP = 4
LVDIP = 2
TMR3IP = 1
; PIR2
OSCFIF = 7
EEIF = 4
LVDIF = 2
TMR3IF = 1
; PIE2
OSCFIE = 7
EEIE = 4
LVDIE = 2
TMR3IE = 1
; IPR1
ADIP = 6
RCIP = 5
TXIP = 4
CCP1IP = 2
TMR2IP = 1
TMR1IP = 0
; PIR1
ADIF = 6
RCIF = 5
TXIF = 4
CCP1IF = 2
TMR2IF = 1
TMR1IF = 0
; PIE1
ADIE = 6
RCIE = 5
TXIE = 4
CCP1IE = 2
TMR2IE = 1
TMR1IE = 0
; OSCTUNE
TUN5 = 5
TUN4 = 4
TUN3 = 3
TUN2 = 2
TUN1 = 1
TUN0 = 0
; PORTA
RA0 = 160
AN0 = 0
RA1 = 161
AN1 = 0
LVDIN = 0
RA2 = 162
AN2 = 0
VREFM = 0
RA3 = 163
AN3 = 0
VREFP = 0
RA4 = 164
T0CKI = 12
RA5 = 165
RA6 = 166
OSC2 = 0
CLKO = 0
RA7 = 167
OSC1 = 0
CLKI = 0
; PORTB
RB0 = 176
INT0 = 0
AN4 = 0
RB1 = 177
INT1 = 0
AN5 = 0
TX = 0
CK = 0
RB2 = 178
INT2 = 0
P1B = 27
RB3 = 179
CCP1 = 12
P1A = 26
RB4 = 180
KBI0 = 11
AN6 = 0
RX = 0
RB5 = 181
KBI1 = 11
PGM = 0
RB6 = 182
KBI2 = 11
PGC = 0
T1OSO = 1
T1CKI = 28
T13CKI = 316
P1C = 28
RB7 = 183
KBI3 = 11
T1OSI = 1
PGD = 0
P1D = 29
 #DEFINE W 0
 #DEFINE F 1
 #DEFINE A 0
 #DEFINE _CLOCK 8000000
 #DEFINE CLRW CLRF 4072,0
 #DEFINE NEGW NEGF 4072,0
 #DEFINE SKPC BTFSS 4056,0,0
 #DEFINE SKPNC BTFSC 4056,0,0
 #DEFINE CLRC BCF 4056,0,0
 #DEFINE SETC BSF 4056,0,0
 #DEFINE SKPZ BTFSS 4056,2,0
 #DEFINE SKPNZ BTFSC 4056,2,0
 #DEFINE CLRZ BCF 4056,2,0
 #DEFINE SETZ BSF 4056,2,0
SB_SV0 EQU 0
SB_SV0H EQU 1
SB_SV0HH EQU 2
SB_SV0HHH EQU 3
SB_SV1 EQU 4
SB_SV1H EQU 5
SB_SV2 EQU 6
SB_SV2H EQU 7
SB_SV2HH EQU 8
SB_SV2HHH EQU 9
SB_SV3 EQU 10
SB_SV3H EQU 11
SB_SV3HH EQU 12
SB_SV3HHH EQU 13
SB_SV4 EQU 14
SB_SV4H EQU 15
SB_SV5 EQU 16
SB_SV5H EQU 17
SB_SV5HH EQU 18
SB_SV5HHH EQU 19
SB_SV6 EQU 20
SB_SV6H EQU 21
SB_SV6HH EQU 22
SB_SV6HHH EQU 23
SB_SV7 EQU 24
A0 EQU 4073
A0H EQU 4074
A1 EQU 4065
A1H EQU 4066
A2 EQU 4057
A2H EQU 4058
TBPTR EQU 4086
TBPTRH EQU 4087
F0_U08 EQU 25
F1_U32 EQU 26
F1_U32H EQU 27
F1_U32HH EQU 28
F1_U32HHH EQU 29
F5_U32 EQU 30
F5_U32H EQU 31
F5_U32HH EQU 32
F5_U32HHH EQU 33
F9_U08 EQU 34
F10_U08 EQU 35
F11_U08 EQU 36
F12_U08 EQU 37
F13_U08 EQU 38
F14_U200 EQU 39
F14_U200H EQU 40
F39_U08 EQU 64
F40_U08 EQU 65
M0_U08 EQU 66
M1_U08 EQU 67
M2_U08 EQU 68
M3_U08 EQU 69
M4_U08 EQU 70
M5_U08 EQU 71
M6_U08 EQU 72
M7_U08 EQU 73
M8_U16 EQU 74
M8_U16H EQU 75
M10_U16 EQU 76
M10_U16H EQU 77
        ORG 0X00
        GOTO SBCDSTD
        ORG 0X08
        BRA ISR_TMR2_INTERRUPT_0
SB_DIV_U_32X32
        CLRF 16,0
        CLRF 17,0
        CLRF 18,0
        CLRF 19,0
        CLRF 10,0
        CLRF 11,0
        CLRF 12,0
        CLRF 13,0
        MOVF 9,0,0
        IORWF 8,0,0
        IORWF 7,0,0
        IORWF 6,0,0
        BZ DIV_U_32X32_EXIT
        MOVLW 32
        MOVWF 4083
DIV_U_32X32_LOOP
        BCF 4056,0,0
        RLCF 0,1,0
        RLCF 1,1,0
        RLCF 2,1,0
        RLCF 3,1,0
        RLCF 10,1,0
        RLCF 11,1,0
        RLCF 12,1,0
        RLCF 13,1,0
        MOVF 9,0,0
        SUBWF 13,0,0
        BNZ $ + 18
        MOVF 8,0,0
        SUBWF 12,0,0
        BNZ $ + 12
        MOVF 7,0,0
        SUBWF 11,0,0
        BNZ $ + 6
        MOVF 6,0,0
        SUBWF 10,0,0
        BNC DIV_U_32X32_SKIP
        MOVF 6,0,0
        SUBWF 10,1,0
        MOVF 7,0,0
        BTFSS 4056,0,0
        INCFSZ 7,0,0
        SUBWF 11,1,0
        MOVF 8,0,0
        BTFSS 4056,0,0
        INCFSZ 8,0,0
        SUBWF 12,1,0
        MOVF 9,0,0
        BTFSS 4056,0,0
        INCFSZ 9,0,0
        SUBWF 13,1,0
        BSF 4056,0,0
DIV_U_32X32_SKIP
        RLCF 16,1,0
        RLCF 17,1,0
        RLCF 18,1,0
        RLCF 19,1,0
        DECFSZ 4083,1,0
        BRA DIV_U_32X32_LOOP
DIV_U_32X32_EXIT
        RETURN 0
SBCDSTD
        BRA MAIN
PROC_RAND_0
?I000000_F003_000045_P000001 ; L#MK SEED = (MAGICA * SEED + MAGICB) MOD MAGICC
        MOVF M0_U08,0,0
        MULLW 7
        MOVFF PRODL,F1_U32
        MOVFF PRODH,F1_U32H
        CLRF F1_U32HH,0
        CLRF F1_U32HHH,0
        MOVLW 7
        ADDWF F1_U32,0,0
        MOVWF F5_U32,0
        MOVLW 0
        ADDWFC F1_U32H,0,0
        MOVWF F5_U32H,0
        MOVLW 0
        ADDWFC F1_U32HH,0,0
        MOVWF F5_U32HH,0
        MOVLW 0
        ADDWFC F1_U32HHH,0,0
        MOVWF F5_U32HHH,0
        MOVFF F5_U32HHH,SB_SV0HHH
        MOVFF F5_U32HH,SB_SV0HH
        MOVFF F5_U32H,SB_SV0H
        MOVFF F5_U32,SB_SV0
        CLRF SB_SV2HHH,0
        CLRF SB_SV2HH,0
        CLRF SB_SV2H,0
        SETF SB_SV2,0
        RCALL SB_DIV_U_32X32
        MOVFF SB_SV3,M0_U08
?I000001_F003_000046_P000001 ; L#MK RESULT = SEED
        MOVFF M0_U08,F0_U08
?I000002_F003_000047_P000001 ; L#MK END FUNCTION
        RETURN 0
PROC_INITIALIZE_0
?I000003_F003_000058_P000002 ; L#MK SEED = INITIALSEED
        MOVFF F9_U08,M0_U08
?I000004_F003_000059_P000002 ; L#MK SEED = RAND()
        RCALL PROC_RAND_0
        MOVFF F0_U08,M0_U08
?I000005_F003_000060_P000002 ; L#MK END SUB
        RETURN 0
PROC_TMR2_INITIALIZE_0
?I000006_F000_000060_P000036 ; L#MK TMR2ON = 0                // DISABLE TMR2
        BCF T2CON,2,0
?I000007_F000_000061_P000036 ; L#MK TMR2IE = 0                // TURN OFF TMR2 INTERRUPTS
        BCF PIE1,1,0
?I000008_F000_000063_P000036 ; L#MK PR2 = 149                 // TMR2 PERIOD REGISTER PR2
        MOVLW 149
        MOVWF PR2,0
?I000009_F000_000064_P000036 ; L#MK T2CON = %00000001         // T2CON 0:1 = PRESCALE
        MOVLW 1
        MOVWF T2CON,0
?I000010_F000_000074_P000036 ; L#MK TMR2 = 0                  // RESET TMR2 VALUE
        CLRF TMR2,0
?I000011_F000_000075_P000036 ; L#MK TMR2IE = 1                // ENABLE TMR2 INTERRUPTS
        BSF PIE1,1,0
?I000012_F000_000076_P000036 ; L#MK TMR2ON = 1                // ENABLE TMR2 TO INCREMENT
        BSF T2CON,2,0
?I000013_F000_000077_P000036 ; L#MK ENABLE(TMR2_INTERRUPT)
        BSF INTCON,7,0
?I000014_F000_000078_P000036 ; L#MK END SUB
        RETURN 0
ISR_TMR2_INTERRUPT_0
?I000015_F000_000027_P000035 ; L#MK HIGH(SIGNAL_PIN)
        BSF LATA,0,0
        BCF TRISA,0,0
        MOVFF FSR0L,F10_U08
        MOVFF FSR0H,F11_U08
        MOVFF FSR1L,F12_U08
        MOVFF FSR1H,F13_U08
        LFSR 0,F14_U200
        CLRF FSR1L,0
        CLRF FSR1H,0
        MOVLW 25
        MOVFF POSTINC1,POSTINC0
        DECFSZ WREG,1,0
        BRA $ - 6
        MOVFF PRODL,F39_U08
        MOVFF PRODH,F40_U08
?I000016_F000_000029_P000035 ; L#MK IF TMR2IF = 1 THEN        // CHECK IF THE INTERRUPT WAS FROM...
; CMPNE_BI_NM_LBL PIR1,1,1,ENDIF_6
; CMPNE_NM_BI_LBL 1,PIR1,1,ENDIF_6
        BTFSS PIR1,1,0
        BRA ENDIF_6
?I000017_F000_000030_P000035 ; L#MK TMR2IF = 0            // CLEAR THE TMR2 INTERRUPT FLAG
        BCF PIR1,1,0
?I000018_F000_000031_P000035 ; L#MK US = US + 50
        MOVLW 50
        ADDWF M8_U16,1,0
        MOVLW 0
        ADDWFC M8_U16H,1,0
?I000019_F000_000032_P000035 ; L#MK IF US >= 1000 THEN
; CMPLT_WD_NM_LBL M8_U16,1000,ENDIF_7
; CMPGT_NM_WD_LBL 1000,M8_U16,ENDIF_7
        MOVLW 232
        SUBWF M8_U16,0,0
        MOVLW 3
        SUBWFB M8_U16H,0,0
        BNC ENDIF_7
?I000020_F000_000033_P000035 ; L#MK US = US - 1000
        MOVLW 232
        SUBWF M8_U16,1,0
        MOVLW 3
        SUBWFB M8_U16H,1,0
?I000021_F000_000034_P000035 ; L#MK INC(MS)
        INFSNZ M10_U16,1,0
        INCF M10_U16H,1,0
ENDIF_7
?I000022_F000_000036_P000035 ; L#MK INC(RED_DUTYVAL)
        INCF M4_U08,1,0
?I000023_F000_000037_P000035 ; L#MK INC(GREEN_DUTYVAL)
        INCF M5_U08,1,0
?I000024_F000_000038_P000035 ; L#MK INC(BLUE_DUTYVAL)
        INCF M6_U08,1,0
?I000025_F000_000039_P000035 ; L#MK IF RED_DUTYVAL > RED_DUTY OR RED_DUTY = 0 THEN
; CMPGT_BT_BT_LBL M4_U08,M1_U08,TRUE_29
        MOVF M4_U08,0,0
        SUBWF M1_U08,0,0
        BNC TRUE_29
; CMPNE_BT_NM_LBL M1_U08,0,FALSE_15
        TSTFSZ M1_U08,0
        BRA FALSE_15
TRUE_29
?I000026_F000_000040_P000035 ; L#MK RED_PIN = 0
        BCF LATB,0,0
        BRA ENDIF_8
FALSE_15
?I000027_F000_000042_P000035 ; L#MK RED_PIN = 1
        BSF LATB,0,0
ENDIF_8
?I000028_F000_000044_P000035 ; L#MK IF GREEN_DUTYVAL > GREEN_DUTY OR GREEN_DUTY = 0 THEN
; CMPGT_BT_BT_LBL M5_U08,M2_U08,TRUE_31
        MOVF M5_U08,0,0
        SUBWF M2_U08,0,0
        BNC TRUE_31
; CMPNE_BT_NM_LBL M2_U08,0,FALSE_16
        TSTFSZ M2_U08,0
        BRA FALSE_16
TRUE_31
?I000029_F000_000045_P000035 ; L#MK GREEN_PIN = 0
        BCF LATB,1,0
        BRA ENDIF_9
FALSE_16
?I000030_F000_000047_P000035 ; L#MK GREEN_PIN = 1
        BSF LATB,1,0
ENDIF_9
?I000031_F000_000049_P000035 ; L#MK IF BLUE_DUTYVAL > BLUE_DUTY OR BLUE_DUTY = 0 THEN
; CMPGT_BT_BT_LBL M6_U08,M3_U08,TRUE_33
        MOVF M6_U08,0,0
        SUBWF M3_U08,0,0
        BNC TRUE_33
; CMPNE_BT_NM_LBL M3_U08,0,FALSE_17
        TSTFSZ M3_U08,0
        BRA FALSE_17
TRUE_33
?I000032_F000_000050_P000035 ; L#MK BLUE_PIN = 0
        BCF LATB,2,0
        BRA ENDIF_10
FALSE_17
?I000033_F000_000052_P000035 ; L#MK BLUE_PIN = 1
        BSF LATB,2,0
ENDIF_10
ENDIF_6
        MOVFF F40_U08,PRODH
        MOVFF F39_U08,PRODL
        CLRF FSR0L,0
        CLRF FSR0H,0
        LFSR 1,F14_U200
        MOVLW 25
        MOVFF POSTINC1,POSTINC0
        DECFSZ WREG,1,0
        BRA $ - 6
        MOVFF F13_U08,FSR1H
        MOVFF F12_U08,FSR1L
        MOVFF F11_U08,FSR0H
        MOVFF F10_U08,FSR0L
?I000034_F000_000056_P000035 ; L#MK LOW(SIGNAL_PIN)
        BCF LATA,0,0
        BCF TRISA,0,0
?I000035_F000_000057_P000035 ; L#MK END INTERRUPT
        RETFIE 1
MAIN
        BSF RCON,7,0
?I000036_F002_000003_M000002 ; L#MK OSCCON = %01110110
        MOVLW 118
        MOVWF OSCCON,0
?I000037_F000_000081_M000000 ; L#MK LOW(RED_PIN)
        BCF LATB,0,0
        BCF TRISB,0,0
?I000038_F000_000082_M000000 ; L#MK LOW(GREEN_PIN)
        BCF LATB,1,0
        BCF TRISB,1,0
?I000039_F000_000083_M000000 ; L#MK LOW(BLUE_PIN)
        BCF LATB,2,0
        BCF TRISB,2,0
?I000040_F000_000084_M000000 ; L#MK RED_DUTY = 0
        CLRF M1_U08,0
?I000041_F000_000085_M000000 ; L#MK GREEN_DUTY = 0
        CLRF M2_U08,0
?I000042_F000_000086_M000000 ; L#MK BLUE_DUTY = 0
        CLRF M3_U08,0
?I000043_F000_000087_M000000 ; L#MK RED_DUTYVAL = 0
        CLRF M4_U08,0
?I000044_F000_000088_M000000 ; L#MK GREEN_DUTYVAL = 0
        CLRF M5_U08,0
?I000045_F000_000089_M000000 ; L#MK BLUE_DUTYVAL = 0
        CLRF M6_U08,0
?I000046_F000_000091_M000000 ; L#MK US = 0
        CLRF M8_U16H,0
        CLRF M8_U16,0
?I000047_F000_000092_M000000 ; L#MK MS = 0
        CLRF M10_U16H,0
        CLRF M10_U16,0
?I000048_F000_000094_M000000 ; L#MK RANDGEN.INITIALIZE(128)       // INITIALIZE THE RANDOM NUMBE...
        MOVLW 128
        MOVWF F9_U08,0
        RCALL PROC_INITIALIZE_0
?I000049_F000_000095_M000000 ; L#MK TMR2_INITIALIZE               // SETUP AND ENABLE TMR2
        RCALL PROC_TMR2_INITIALIZE_0
?I000050_F000_000097_M000000 ; L#MK WHILE TRUE                    // CREATE AN INFINITE LOOP
WHILE_0
?I000051_F000_000098_M000000 ; L#MK RANDOMVAL = RANDGEN.RAND  // GRAB A RANDOM NUMBER FROM 0 TO ...
        RCALL PROC_RAND_0
        MOVFF F0_U08,M7_U08
?I000052_F000_000099_M000000 ; L#MK SELECT RANDOMVAL         // FIND OUT WHAT COLOUR TO INCREASE...
?I000053_F000_000100_M000000 ; L#MK CASE 0 TO 42
; CMPLT_BT_NM_LBL M7_U08,0,FALSE_4
; CMPGT_BT_NM_LBL M7_U08,42,FALSE_4
        MOVLW 43
        CPFSLT M7_U08
        BRA FALSE_4
?I000054_F000_000101_M000000 ; L#MK WHILE RED_DUTY < 255
WHILE_1
; CMPGE_BT_NM_LBL M1_U08,255,FALSE_5
        INFSNZ M1_U08,0,0
        BRA FALSE_5
?I000055_F000_000102_M000000 ; L#MK MS = 0
        CLRF M10_U16H,0
        CLRF M10_U16,0
REPEAT_0
?I000056_F000_000104_M000000 ; L#MK UNTIL MS = 19
; CMPNE_WD_NM_LBL M10_U16,19,REPEAT_0
; CMPNE_NM_WD_LBL 19,M10_U16,REPEAT_0
        MOVF M10_U16,0,0
        XORLW 19
        IORWF M10_U16H,0,0
        BNZ REPEAT_0
?I000057_F000_000105_M000000 ; L#MK INC(RED_DUTY)
        INCF M1_U08,1,0
        BRA WHILE_1
FALSE_5
        BRA ENDIF_5
FALSE_4
?I000058_F000_000107_M000000 ; L#MK CASE 43 TO 84
; CMPLT_BT_NM_LBL M7_U08,43,FALSE_6
; CMPGT_NM_BT_LBL 43,M7_U08,FALSE_6
        MOVLW 42
        CPFSGT M7_U08
        BRA FALSE_6
; CMPGT_BT_NM_LBL M7_U08,84,FALSE_6
        MOVLW 85
        CPFSLT M7_U08
        BRA FALSE_6
?I000059_F000_000108_M000000 ; L#MK WHILE RED_DUTY > 0
WHILE_2
; CMPLE_BT_NM_LBL M1_U08,0,FALSE_7
        MOVF M1_U08,1,0
        BZ FALSE_7
?I000060_F000_000109_M000000 ; L#MK MS = 0
        CLRF M10_U16H,0
        CLRF M10_U16,0
REPEAT_1
?I000061_F000_000111_M000000 ; L#MK UNTIL MS = 19
; CMPNE_WD_NM_LBL M10_U16,19,REPEAT_1
; CMPNE_NM_WD_LBL 19,M10_U16,REPEAT_1
        MOVF M10_U16,0,0
        XORLW 19
        IORWF M10_U16H,0,0
        BNZ REPEAT_1
?I000062_F000_000112_M000000 ; L#MK DEC(RED_DUTY)
        DECF M1_U08,1,0
        BRA WHILE_2
FALSE_7
        BRA ENDIF_5
FALSE_6
?I000063_F000_000114_M000000 ; L#MK CASE 84 TO 127
; CMPLT_BT_NM_LBL M7_U08,84,FALSE_8
; CMPGT_NM_BT_LBL 84,M7_U08,FALSE_8
        MOVLW 83
        CPFSGT M7_U08
        BRA FALSE_8
; CMPGT_BT_NM_LBL M7_U08,127,FALSE_8
        MOVLW 128
        CPFSLT M7_U08
        BRA FALSE_8
?I000064_F000_000115_M000000 ; L#MK WHILE GREEN_DUTY < 255
WHILE_3
; CMPGE_BT_NM_LBL M2_U08,255,FALSE_9
        INFSNZ M2_U08,0,0
        BRA FALSE_9
?I000065_F000_000116_M000000 ; L#MK MS = 0
        CLRF M10_U16H,0
        CLRF M10_U16,0
REPEAT_2
?I000066_F000_000118_M000000 ; L#MK UNTIL MS = 19
; CMPNE_WD_NM_LBL M10_U16,19,REPEAT_2
; CMPNE_NM_WD_LBL 19,M10_U16,REPEAT_2
        MOVF M10_U16,0,0
        XORLW 19
        IORWF M10_U16H,0,0
        BNZ REPEAT_2
?I000067_F000_000119_M000000 ; L#MK INC(GREEN_DUTY)
        INCF M2_U08,1,0
        BRA WHILE_3
FALSE_9
        BRA ENDIF_5
FALSE_8
?I000068_F000_000121_M000000 ; L#MK CASE 128 TO 170
; CMPLT_BT_NM_LBL M7_U08,128,FALSE_10
; CMPGT_NM_BT_LBL 128,M7_U08,FALSE_10
        MOVLW 127
        CPFSGT M7_U08
        BRA FALSE_10
; CMPGT_BT_NM_LBL M7_U08,170,FALSE_10
        MOVLW 171
        CPFSLT M7_U08
        BRA FALSE_10
?I000069_F000_000122_M000000 ; L#MK WHILE GREEN_DUTY > 0
WHILE_4
; CMPLE_BT_NM_LBL M2_U08,0,FALSE_11
        MOVF M2_U08,1,0
        BZ FALSE_11
?I000070_F000_000123_M000000 ; L#MK MS = 0
        CLRF M10_U16H,0
        CLRF M10_U16,0
REPEAT_3
?I000071_F000_000125_M000000 ; L#MK UNTIL MS = 19
; CMPNE_WD_NM_LBL M10_U16,19,REPEAT_3
; CMPNE_NM_WD_LBL 19,M10_U16,REPEAT_3
        MOVF M10_U16,0,0
        XORLW 19
        IORWF M10_U16H,0,0
        BNZ REPEAT_3
?I000072_F000_000126_M000000 ; L#MK DEC(GREEN_DUTY)
        DECF M2_U08,1,0
        BRA WHILE_4
FALSE_11
        BRA ENDIF_5
FALSE_10
?I000073_F000_000128_M000000 ; L#MK CASE 170 TO 212
; CMPLT_BT_NM_LBL M7_U08,170,FALSE_12
; CMPGT_NM_BT_LBL 170,M7_U08,FALSE_12
        MOVLW 169
        CPFSGT M7_U08
        BRA FALSE_12
; CMPGT_BT_NM_LBL M7_U08,212,FALSE_12
        MOVLW 213
        CPFSLT M7_U08
        BRA FALSE_12
?I000074_F000_000129_M000000 ; L#MK WHILE BLUE_DUTY < 255
WHILE_5
; CMPGE_BT_NM_LBL M3_U08,255,FALSE_13
        INFSNZ M3_U08,0,0
        BRA FALSE_13
?I000075_F000_000130_M000000 ; L#MK MS = 0
        CLRF M10_U16H,0
        CLRF M10_U16,0
REPEAT_4
?I000076_F000_000132_M000000 ; L#MK UNTIL MS = 19
; CMPNE_WD_NM_LBL M10_U16,19,REPEAT_4
; CMPNE_NM_WD_LBL 19,M10_U16,REPEAT_4
        MOVF M10_U16,0,0
        XORLW 19
        IORWF M10_U16H,0,0
        BNZ REPEAT_4
?I000077_F000_000133_M000000 ; L#MK INC(BLUE_DUTY)
        INCF M3_U08,1,0
        BRA WHILE_5
FALSE_13
        BRA ENDIF_5
FALSE_12
?I000078_F000_000135_M000000 ; L#MK CASE 212 TO 255
; CMPLT_BT_NM_LBL M7_U08,212,ENDIF_5
; CMPGT_NM_BT_LBL 212,M7_U08,ENDIF_5
        MOVLW 211
        CPFSGT M7_U08
        BRA ENDIF_5
; CMPGT_BT_NM_LBL M7_U08,255,ENDIF_5
?I000079_F000_000136_M000000 ; L#MK WHILE BLUE_DUTY > 0
WHILE_6
; CMPLE_BT_NM_LBL M3_U08,0,FALSE_14
        MOVF M3_U08,1,0
        BZ FALSE_14
?I000080_F000_000137_M000000 ; L#MK MS = 0
        CLRF M10_U16H,0
        CLRF M10_U16,0
REPEAT_5
?I000081_F000_000139_M000000 ; L#MK UNTIL MS = 19
; CMPNE_WD_NM_LBL M10_U16,19,REPEAT_5
; CMPNE_NM_WD_LBL 19,M10_U16,REPEAT_5
        MOVF M10_U16,0,0
        XORLW 19
        IORWF M10_U16H,0,0
        BNZ REPEAT_5
?I000082_F000_000140_M000000 ; L#MK DEC(BLUE_DUTY)
        DECF M3_U08,1,0
        BRA WHILE_6
FALSE_14
ENDIF_5
        BRA WHILE_0
?I000083_END; L#MK
SBGLB2
        SLEEP
        BRA SBGLB2
 CONFIG OSC = HS
 CONFIG IESO = OFF
 CONFIG PWRT = ON
 CONFIG BOR = ON
 CONFIG BORV = 27
 CONFIG WDT = OFF
 CONFIG WDTPS = 128
 CONFIG STVR = ON
 CONFIG LVP = OFF
 CONFIG DEBUG = OFF
SB#ASMEND
        END
